import javax.swing.JPanel;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Cursor;
/**Modificacion: Se creo el metodo toggleCursor() en esta clase.*/
public class PhysicsLabPanel extends JPanel { 
   private MyWorld world;
   private MouseListener mListener;
   private Cursor defaultCursor;
   private Cursor crossCursor;
   
   public PhysicsLabPanel(MyWorld w){
      world = w;
      mListener = new MouseListener(w, this);
      addMouseMotionListener(mListener);
      addMouseListener(mListener);
      defaultCursor = new Cursor(java.awt.Cursor.DEFAULT_CURSOR);
      crossCursor = new Cursor(java.awt.Cursor.CROSSHAIR_CURSOR);
   }
   public void paintComponent(Graphics g){
      super.paintComponent(g); // it paints the background
      Graphics2D g2 = (Graphics2D)g;
      world.paintComponent(g2);
   }
   public void enableMouseListener(){
      addMouseMotionListener(mListener);
      addMouseListener(mListener);         
   }
   public void desableMouseListener(){
      removeMouseMotionListener(mListener);
      removeMouseListener(mListener);
   }
/**Metodo para alternar el cursor desde el cursor por defecto a el cursor en forma de cruz.*/
   public void toggleCursor(){
       
       if(world.isRemoving()){
           setCursor(crossCursor);
       }else{
           setCursor(defaultCursor);
       }
   }
   
   
}
