/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author jub
 */
/** Esta clase hereda de Spring y de esta manera solo requiere implementar el metodo getForce para cumplir con el objetivo.*/
public class Rubber extends Spring {
/** Constructor por defecto no utilizable publicamente.*/
    private Rubber() {
        super();
    }
/** Constructor.*/
    public Rubber(float restLength, float stiffness) {
        super(restLength, stiffness);
    }


 
/** Este metodo debio ser reimplementado para que la fuerza sea cero en caso de que el resorte este en un largo menor o igual al de reposo.
@param ae Elemento enganchable.
*/
    public Vector2D getForce(AttachableElement ae) {
        Vector2D force = new Vector2D();
        if ((a_end == null) || (b_end == null)) {
            return force;
        }
        if ((ae != a_end) && (ae != b_end)) {
            return force;
        }
        Vector2D springVector = getVector();
        double stretch = springVector.module() - restLength;
/** En caso de ser stretch <0, entonces retorna inmediatamente el vector fuerza recientemente creado (con valor 0).*/
        if(stretch<0) return force;
        force = springVector.unitary().times(stretch * stiffness);
        if (ae == a_end) {
            return force;
        }
        return force.times(-1.0);
    }
}
